#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySummerPlanRoketCFG.h"
std::auto_ptr<M_ActivitySummerPlanRoketCFG> M_ActivitySummerPlanRoketCFG::msSingleton(nullptr);

int M_ActivitySummerPlanRoketCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanRoketCFGData* M_ActivitySummerPlanRoketCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySummerPlanRoketCFGData>& M_ActivitySummerPlanRoketCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanRoketCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySummerPlanRoketCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanRoketCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mHeight = element->IntAttribute("Height");
		data.mGiftID = element->IntAttribute("GiftID");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* ShowItem = element->Attribute("ShowItem");
			std::vector<std::string> vecShowItem;
			boost::split(vecShowItem, ShowItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowItem[i].c_str(), &temp))
				{
					data.mShowItem.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySummerPlanRoketCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanRoketCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySummerPlanRoketCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySummerPlanRoketCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySummerPlanRoketCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Height", data.mHeight);
		LuaCfgHelper::readInt(L, "GiftID", data.mGiftID);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readVectorInt(L, "ShowItem", data.mShowItem);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySummerPlanRoketCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanRoketCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySummerPlanRoketCFG* M_ActivitySummerPlanRoketCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanRoketCFG());
	}
	return msSingleton.get();
}

void M_ActivitySummerPlanRoketCFG::Release()
{
	msSingleton.reset(nullptr);
}
